/******************************************************************************
 *  NEOPOP - Emulator as in Dreamland
 *  Copyright (C) 2001-2002 neopop_uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ***************************************************************************/

#include <neopop.h>
#include <font.h>
#include <dkpro.h>
#include <zlib.h>

extern unsigned int *xfb[2];
extern int whichfb;

/*
 * Unpack the devkit pro logo
 */
unsigned int *dkproraw;

int
dkunpack ()
{
  unsigned long res, inbytes, outbytes;

  inbytes = dkpro_COMPRESSED;
  outbytes = dkpro_RAW;
  dkproraw = malloc (dkpro_RAW + 16);

  res =
    uncompress ((char *) dkproraw, &outbytes, (char *) &dkpro[0], inbytes);

  if (res == Z_OK)
    return 1;

  free (dkproraw);
  return 0;
}

/* 
 * This is the legal stuff - which must be shown at program startup 
 * Any derivative work MUST include the same textual output.
 *
 * In other words, play nice and give credit where it's due.
 */
void
legal ()
{
  ClearScreen ();
  WriteCentre (134, "NEOPOP : Emulator as in Dreamland");
  WriteCentre (148, "(C) 2001-2002 neopop_uk");
  WriteCentre (204, "This is free software, and you are welcome to      ");
  WriteCentre (218, "redistribute it under the conditions of the        ");
  WriteCentre (232, "GNU GENERAL PUBLIC LICENSE Version 2               ");
  WriteCentre (260, "Additionally, the developers of this port disclaims");
  WriteCentre (274, "all copyright interests in the Nintendo Gamecube   ");
  WriteCentre (288, "Porting code. You are free to use it as you wish.  ");

  if (dkunpack ())
    {
      int w, h, p, dispoffset;
      p = 0;
      dispoffset = (316 * 320) + ((640 - dkpro_WIDTH) >> 2);

      for (h = 0; h < dkpro_HEIGHT; h++)
	{
	  for (w = 0; w < dkpro_WIDTH >> 1; w++)
	    xfb[whichfb][dispoffset + w] = dkproraw[p++];

	  dispoffset += 320;
	}

      free (dkproraw);
    }
  else
    WriteCentre (344, "Developed with DevkitPPC and libOGC");

  WriteCentre (386, "Press A to continue");

  SetScreen ();
  WaitButtonA ();
}
