/******************************************************************************
 *  NEOPOP - Emulator as in Dreamland
 *  Copyright (C) 2001-2002 neopop_uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Nintendo Gamecube Menus
 *
 * Please put any user menus here! - softdev March 12 2006
 ***************************************************************************/
#include <neopop.h>
#include <font.h>
#include <filesel.h>
#include <dvd.h>

extern void miscellaneous ();
extern void menumcard ();

#define PSOSDLOADID 0x7c6000a6

/***************************************************************************
 * drawmenu
 *
 * As it says, simply draws the menu with a highlight on the currently
 * selected item :)
 ***************************************************************************/
char menutitle[60] = { "Main Menu" };
void drawmenu (char items[][20], int maxitems, int selected)
{
  int i;
  int ypos;

  ypos = (310 - (fheight * maxitems)) >> 1;
  ypos += 120;

  setfontcolour (COLOR_WHITE);
  ClearScreen ();
  setdoublewidth (1);
  WriteCentre (134, menutitle);

  for (i = 0; i < maxitems; i++)
  {
    if (i == selected)
	{
	  setfontcolour (COLOR_BLACK);
	  fntDrawBoxFilled (100, (i * fheight) + ypos, 540,((i + 1) * fheight) + ypos, COLOR_WHITE);
	  WriteCentre (i * fheight + ypos, (char *) items[i]);
	  setfontcolour (COLOR_WHITE);
	}
    else WriteCentre (i * fheight + ypos, (char *) items[i]);
  }

  setdoublewidth (0);
  SetScreen ();
}

/****************************************************************************
 * domenu
 *
 * Returns index into menu array when A is pressed, -1 for B
 ****************************************************************************/
int menu = 0;	/** Set to zero before 1st call **/
int domenu (char items[][20], int maxitems)
{
  int redraw = 1;
  int quit = 0;
  short p;
  int ret = 0;
  signed char a;

  while (quit == 0)
  {
    if (redraw)
	{
	  drawmenu (&items[0], maxitems, menu);
	  redraw = 0;
	}

    p = PAD_ButtonsDown (0);
    a = PAD_StickY (0);

	/*** Look for up ***/
    if ((p & PAD_BUTTON_UP) || (a > 70))
	{
	  redraw = 1;
	  menu--;
      if (menu < 0) menu = maxitems - 1;
	}

	/*** Look for down ***/
    if ((p & PAD_BUTTON_DOWN) || (a < -70))
	{
	  redraw = 1;
	  menu++;
      if (menu == maxitems) menu = 0;
	}

    if (p & PAD_BUTTON_A)
	{
	  quit = 1;
	  ret = menu;
	}

    if (p & PAD_BUTTON_B)
	{
	  quit = 1;
	  ret = -1;
	}
  }

  return ret;
}

/****************************************************************************
 * Top menu
 *
 * WIP3 - Action Replay officially gone.
 ****************************************************************************/
int maincount = 8;
char mainmenu[8][20] = {
{"Play Game"}, 
{"Load from DVD"}, {"Stop DVD Motor"},
{"Load from SDCARD"}, {"SD/PSO Reload"},
{"Reset Emulator"}, {"Miscellaneous"},
{"State Management"},
};

void MainMenu ()
{
  menu = 0;
  int ret;
  int quit = 0;
  int *psoid = (int *) 0x80001800;

	/*** Stock PSO/SD Reload call ***/
  void (*PSOReload) () = (void (*)()) 0x80001800;

  strcpy (menutitle, "Main Menu");

  while (quit == 0)
  {
    ret = domenu (&mainmenu[0], maincount);
    switch (ret)
	{
	  case -1:			/*** Button B ***/
      case  0: /*** Play Game ***/
	    quit = 1;
	    break;
	  case 1: /*** Load from DVD ***/
	    OpenDVD ();
		menu = 0;
	    break;
      case 2:
		 dvd_motor_off ();
	     break;
	  case 3:
	    OpenSD ();
	    menu = 0;
	    break;
      case 4:
	    if (psoid[0] == PSOSDLOADID) PSOReload ();
	    break;
	  case 5:
	    reset ();
	    quit = 1;
	    break;
	  case 6:
	    miscellaneous ();
	    break;
	  case 7:
	    menumcard ();
        break;
	}
  }
  uselessinquiry ();		/*** Stop the DVD from causing clicks while playing ***/
}
