/******************************************************************************
 *  NEOPOP - Emulator as in Dreamland
 *  Copyright (C) 2001-2002 neopop_uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * NGC - Miscellaneous
 ***************************************************************************/
#include <neopop.h>
#include <font.h>

/*** Menu externals ***/
extern int domenu (char items[][20], int maxitems);
extern int menu;
extern char menutitle[];

/*** Option Externals ***/
extern s16 square[];
extern int oldvwidth, oldvheight;

/*** Menu definition ***/
int misccount = 3;
char miscmenu[3][20];

void
miscellaneous ()
{

  int ret;
  int quit = 0;

  int prevmenu = menu;

  strcpy (menutitle, "Miscellaneous Options");

	/*** Capture running values ***/
  sprintf (miscmenu[0], "Scale X     - %02d", square[3]);
  sprintf (miscmenu[1], "Scale Y     - %02d", square[1]);
  strcpy (miscmenu[2], "Return to previous");

  menu = 0;

  while (quit == 0)
    {
      ret = domenu (&miscmenu[0], misccount);

      switch (ret)
	{
	case 0:
	       /*** Scale X ***/
	  square[3] += 2;
	  if (square[3] > 80)
	    square[3] = 40;

	  square[6] = square[3];
	  square[0] = square[9] = -square[3];

	  sprintf (miscmenu[0], "Scale X     - %02d", square[3]);
	  oldvwidth = -1;

	  break;

	case 1:
	       /*** Scale Y ***/
	  square[1] += 2;
	  if (square[1] > 60)
	    square[1] = 30;

	  square[4] = square[1];
	  square[7] = square[10] = -square[1];

	  sprintf (miscmenu[1], "Scale Y     - %02d", square[1]);
	  oldvheight = -1;

	  break;

	case 2:
	  quit = 1;
	  break;
	}
    }

  menu = prevmenu;

}
